/*
 * Sixth 3D engine. Copyright ©2012-2017, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 *
 */

package eu.svjatoslav.sixth.e3d.geometry;

public class Polygon {

    private static boolean intersectsLine(final Point2D point, Point2D p1,
                                          Point2D p2) {

        if (p1.y > p2.y) {
            final Point2D tmp = p1;
            p1 = p2;
            p2 = tmp;
        }

        if (point.y < p1.y)
            return false;
        if (point.y > p2.y)
            return false;

        final double xp = p2.x - p1.x;
        final double yp = p2.y - p1.y;

        final double yp2 = point.y - p1.y;

        final double crossX = p1.x + ((xp * yp2) / yp);

        return point.x >= crossX;

    }

    public static boolean pointWithinPolygon(final Point2D point,
                                             final Point2D p1, final Point2D p2, final Point2D p3) {

        int intersectionCount = 0;

        if (intersectsLine(point, p1, p2))
            intersectionCount++;

        if (intersectsLine(point, p2, p3))
            intersectionCount++;

        if (intersectsLine(point, p3, p1))
            intersectionCount++;

        return intersectionCount == 1;

    }

}
