/*
 * Sixth 3D engine. Copyright ©2012-2017, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 *
 */

package eu.svjatoslav.sixth.e3d.gui.textEditorComponent;

import java.util.HashSet;
import java.util.Set;

public class KeyboardHelper {

    public static final int TAB = 9;
    public static final int DOWN = 40;
    public static final int UP = 38;
    public static final int RIGHT = 39;
    public static final int LEFT = 37;
    public static final int PGDOWN = 34;
    public static final int PGUP = 33;
    public static final int HOME = 36;
    public static final int END = 35;
    public static final int DEL = 127;
    public static final int ENTER = 10;
    public static final int BACKSPACE = 8;
    public static final int ESC = 27;
    public static final int SHIFT = 16;

    private static final Set<Integer> nonText;

    static {
        nonText = new HashSet<>();
        nonText.add(DOWN);
        nonText.add(UP);
        nonText.add(LEFT);
        nonText.add(RIGHT);

        nonText.add(SHIFT);
        nonText.add(ESC);
    }

    public static boolean isAlt(final int modifiers) {
        return (modifiers | 8) == modifiers;
    }

    public static boolean isCtrl(final int modifiers) {
        return (modifiers | 2) == modifiers;
    }

    public static boolean isShift(final int modifiers) {
        return (modifiers | 1) == modifiers;
    }

    public static boolean isText(final int keyCode) {
        return !nonText.contains(keyCode);
    }

}
