/*
 * Sixth 3D engine. Copyright ©2012-2017, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 *
 */

package eu.svjatoslav.sixth.e3d.renderer.raster.shapes.composite.wireframe;

import eu.svjatoslav.sixth.e3d.geometry.Box;
import eu.svjatoslav.sixth.e3d.geometry.Point3D;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.basic.line.LineAppearance;
import eu.svjatoslav.sixth.e3d.renderer.raster.shapes.composite.base.AbstractCompositeShape;

public class WireframeBox extends AbstractCompositeShape {

    public WireframeBox(final Box box,
                        final LineAppearance appearance) {

        this(box.p1, box.p2, appearance);
    }

    public WireframeBox(final Point3D p1, final Point3D p2,
                        final LineAppearance appearance) {
        super();

        addShape(appearance.getLine(new Point3D(p1.x, p1.y, p1.z), new Point3D(
                p2.x, p1.y, p1.z)));
        addShape(appearance.getLine(new Point3D(p1.x, p2.y, p1.z), new Point3D(
                p2.x, p2.y, p1.z)));
        addShape(appearance.getLine(new Point3D(p1.x, p1.y, p1.z), new Point3D(
                p1.x, p2.y, p1.z)));
        addShape(appearance.getLine(new Point3D(p2.x, p1.y, p1.z), new Point3D(
                p2.x, p2.y, p1.z)));

        addShape(appearance.getLine(new Point3D(p1.x, p1.y, p2.z), new Point3D(
                p2.x, p1.y, p2.z)));
        addShape(appearance.getLine(new Point3D(p1.x, p2.y, p2.z), new Point3D(
                p2.x, p2.y, p2.z)));
        addShape(appearance.getLine(new Point3D(p1.x, p1.y, p2.z), new Point3D(
                p1.x, p2.y, p2.z)));
        addShape(appearance.getLine(new Point3D(p2.x, p1.y, p2.z), new Point3D(
                p2.x, p2.y, p2.z)));

        addShape(appearance.getLine(new Point3D(p1.x, p1.y, p1.z), new Point3D(
                p1.x, p1.y, p2.z)));
        addShape(appearance.getLine(new Point3D(p1.x, p2.y, p1.z), new Point3D(
                p1.x, p2.y, p2.z)));
        addShape(appearance.getLine(new Point3D(p2.x, p1.y, p1.z), new Point3D(
                p2.x, p1.y, p2.z)));
        addShape(appearance.getLine(new Point3D(p2.x, p2.y, p1.z), new Point3D(
                p2.x, p2.y, p2.z)));
    }

}
